include agBitMask.inc

.code
	
EditProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	
LOCAL fContinue		:BOOL
LOCAL dwLimit		:DWORD
LOCAL dwStart		:DWORD
LOCAL dwEnd			:DWORD

	.if uMsg==WM_CHAR
		mov fContinue,FALSE
		mov eax,wParam
		.if nOutput==IDRB_DEC && (al >= '0' && al <= '9')
			mov fContinue,TRUE
			mov dwLimit,10
		.elseif nOutput==IDRB_HEX && ((al >= '0' && al <= '9')||(al >= 'A' && al <= 'F')||(al >= 'a' && al <= 'f'))
			mov fContinue,TRUE
			mov dwLimit,8
		.elseif al==VK_BACK
			invoke GetWindowLong,hWnd,GWL_USERDATA
			invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
			ret
		.endif
		.if fContinue
			invoke SendMessage,hWnd,WM_GETTEXTLENGTH,0,0
			.if eax < dwLimit
				invoke GetWindowLong,hWnd,GWL_USERDATA
				invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
				ret
			.else
				invoke SendMessage,hWnd,EM_GETSEL,addr dwStart,addr dwEnd
				mov eax,dwStart
				.if eax != dwEnd
					invoke GetWindowLong,hWnd,GWL_USERDATA
					invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
					ret
				.endif
			.endif
		.endif
	.elseif uMsg==WM_KEYDOWN
		mov fCatchUpdate,TRUE
		invoke GetWindowLong,hWnd,GWL_USERDATA
		invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
		ret
	.else
		invoke GetWindowLong,hWnd,GWL_USERDATA
		invoke CallWindowProc,eax,hWnd,uMsg,wParam,lParam
		ret
	.endif
	xor eax,eax
	ret

EditProc endp

ApplyBin proc hWnd:HWND,idStart:DWORD,number:DWORD
	
LOCAL buffer[36]	:BYTE

	push esi
	invoke dw2bin_ex,number,addr buffer
	lea esi,buffer
	.while byte ptr [esi] != 0
		mov al,byte ptr [esi]
		sub al,'0'
		invoke SetDlgItemInt,hWnd,idStart,al,FALSE
		add esi,1
		add idStart,1
	.endw
	pop esi
	ret

ApplyBin endp

ApplyText proc hWnd:HWND,idText:DWORD,number:DWORD
	
LOCAL buffer[36]	:BYTE

	.if nOutput==IDRB_DEC
		invoke SetDlgItemInt,hWnd,idText,number,FALSE
	.else
		invoke wsprintf,addr buffer,ctext("%X"),number
		invoke SetDlgItemText,hWnd,idText,addr buffer
	.endif
	invoke SendDlgItemMessage,hWnd,idText,WM_GETTEXTLENGTH,0,0
	invoke SendDlgItemMessage,hWnd,idText,EM_SETSEL,eax,eax
	ret

ApplyText endp

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	
LOCAL id			:DWORD
LOCAL buffer[36]	:BYTE
LOCAL hTemp			:HWND

	.if uMsg==WM_CLOSE
		;clear before exit
		mov dwDest,0
		mov dwSrc,0
		mov dwRes,0
		invoke EndDialog,hWnd,NULL
	.elseif uMsg==WM_INITDIALOG
		invoke LoadIcon,hInstance,1
		invoke SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
		mov nOutput,IDRB_HEX
		invoke GetDlgItem,hWnd,IDT_DEST
		mov hTemp,eax
		invoke SetWindowLong,hTemp,GWL_WNDPROC,addr EditProc
		invoke SetWindowLong,hTemp,GWL_USERDATA,eax
		invoke GetDlgItem,hWnd,IDT_SRC
		mov hTemp,eax
		invoke SetWindowLong,hTemp,GWL_WNDPROC,addr EditProc
		invoke SetWindowLong,hTemp,GWL_USERDATA,eax
		invoke SendDlgItemMessage,hWnd,IDRB_HEX,BM_SETCHECK,BST_CHECKED,0
	.elseif uMsg==WM_COMMAND
		hiword wParam
		.if eax==BN_CLICKED
			mov fCatchUpdate,FALSE
			loword wParam
			mov id,eax
			.if id==IDB_CLOSE
				invoke SendMessage,hWnd,WM_CLOSE,0,0
			.elseif id==IDB_NOT_DEST
				not dwDest
				invoke ApplyText,hWnd,IDT_DEST,dwDest
				invoke ApplyBin,hWnd,IDS_DEST0,dwDest
			.elseif id==IDB_NOT_SRC
				not dwSrc
				invoke ApplyText,hWnd,IDT_SRC,dwSrc
				invoke ApplyBin,hWnd,IDS_SRC0,dwSrc
			.elseif(id==IDB_AND || id==IDB_OR || id== IDB_XOR)
				mov eax,dwDest
				.if id==IDB_AND
					and eax,dwSrc
				.elseif id==IDB_OR
					or eax,dwSrc
				.elseif id== IDB_XOR
					xor eax,dwSrc
				.endif
				mov dwRes,eax
				invoke ApplyText,hWnd,IDT_RES,dwRes
				invoke ApplyBin,hWnd,IDS_RES0,dwRes
			.elseif id==IDB_CLEAR
				mov dwDest,0
				invoke ApplyText,hWnd,IDT_DEST,dwDest
				invoke ApplyBin,hWnd,IDS_DEST0,dwDest
				mov dwSrc,0
				invoke ApplyText,hWnd,IDT_SRC,dwSrc
				invoke ApplyBin,hWnd,IDS_SRC0,dwSrc
				mov dwRes,0
				invoke ApplyText,hWnd,IDT_RES,dwRes
				invoke ApplyBin,hWnd,IDS_RES0,dwRes
			.elseif(id==IDB_SHL_DEST || id==IDB_SHR_DEST)
				.if id==IDB_SHL_DEST
					shl dwDest,1
				.else
					shr dwDest,1
				.endif
				invoke ApplyText,hWnd,IDT_DEST,dwDest
				invoke ApplyBin,hWnd,IDS_DEST0,dwDest
			.elseif(id==IDB_SHL_SRC || id==IDB_SHR_SRC)
				.if id==IDB_SHL_SRC
					shl dwSrc,1
				.else
					shr dwSrc,1
				.endif
				invoke ApplyText,hWnd,IDT_SRC,dwSrc
				invoke ApplyBin,hWnd,IDS_SRC0,dwSrc
			.elseif(id >= IDS_DEST0 && id <= IDS_DEST31)
				mov edx,IDS_DEST31
				sub edx,id
				btc dwDest,edx
				invoke ApplyText,hWnd,IDT_DEST,dwDest
				invoke GetDlgItemInt,hWnd,id,0,0
				btc eax,0
				invoke SetDlgItemInt,hWnd,id,eax,FALSE
			.elseif(id >= IDS_SRC0 && id <= IDS_SRC31)
				mov edx,IDS_SRC31
				sub edx,id
				btc dwSrc,edx
				invoke ApplyText,hWnd,IDT_SRC,dwSrc
				invoke GetDlgItemInt,hWnd,id,0,0
				btc eax,0
				invoke SetDlgItemInt,hWnd,id,eax,FALSE
			.elseif id==IDRB_DEC
				.if nOutput==IDRB_HEX
					mov nOutput,IDRB_DEC
					invoke SetDlgItemInt,hWnd,IDT_DEST,dwDest,FALSE
					invoke SetDlgItemInt,hWnd,IDT_SRC,dwSrc,FALSE
					invoke SetDlgItemInt,hWnd,IDT_RES,dwRes,FALSE
				.endif
			.elseif id==IDRB_HEX
				.if nOutput==IDRB_DEC
					mov nOutput,IDRB_HEX
					invoke wsprintf,addr buffer,ctext("%X"),dwDest
					invoke SetDlgItemText,hWnd,IDT_DEST,addr buffer
					invoke wsprintf,addr buffer,ctext("%X"),dwSrc
					invoke SetDlgItemText,hWnd,IDT_SRC,addr buffer
					invoke wsprintf,addr buffer,ctext("%X"),dwRes
					invoke SetDlgItemText,hWnd,IDT_RES,addr buffer
				.endif
			.else
				mov eax,FALSE
				ret
			.endif
		.elseif eax==EN_CHANGE
			loword wParam
			mov id,eax
			invoke SendDlgItemMessage,hWnd,id,WM_GETTEXTLENGTH,0,0
			.if !eax
				invoke SetDlgItemText,hWnd,id,ctext("0")
				invoke SendDlgItemMessage,hWnd,id,EM_SETSEL,0,-1
				mov eax,TRUE
				ret
			.endif
			.if fCatchUpdate
				.if nOutput==IDRB_HEX
					invoke GetDlgItemText,hWnd,id,addr buffer,11
					invoke htodw,addr buffer
				.elseif nOutput==IDRB_DEC
					invoke GetDlgItemInt,hWnd,id,0,0
				.endif
				.if id==IDT_DEST
					mov dwDest,eax
					invoke ApplyBin,hWnd,IDS_DEST0,dwDest
				.elseif id==IDT_SRC
					mov dwSrc,eax
					invoke ApplyBin,hWnd,IDS_SRC0,dwSrc
				.endif
			.endif
		.else
			mov eax,FALSE
			ret
		.endif
	.elseif uMsg==WM_CTLCOLORSTATIC
		invoke GetDlgCtrlID,lParam
		mov id,eax
		invoke SetBkMode,wParam,TRANSPARENT
		.if(id >= IDS_DEST0 && id <= IDS_DEST31)
			invoke SetTextColor,wParam,0FF0000h
			invoke GetSysColorBrush,COLOR_WINDOW
			ret
		.elseif(id >= IDS_SRC0 && id <= IDS_SRC31)
			invoke SetTextColor,wParam,0FFh
			invoke GetSysColorBrush,COLOR_WINDOW
			ret
		.elseif(id >= IDS_RES0 && id <= IDS_RES31) || id==IDT_RES 
			invoke SetTextColor,wParam,80h
		.elseif id == IDS_SHIFT_DEST
			invoke SetTextColor,wParam,0FF0000h
		.elseif id == IDS_SHIFT_SRC
			invoke SetTextColor,wParam,0FFh
		.endif	
		invoke GetSysColorBrush,COLOR_BTNFACE
		ret	
	.elseif uMsg==WM_CTLCOLOREDIT
		invoke GetDlgCtrlID,lParam
		mov id,eax
		.if id == IDT_DEST
			invoke SetTextColor,wParam,0FF0000h
		.elseif id == IDT_SRC
			invoke SetTextColor,wParam,0FFh
		.endif
		invoke GetSysColorBrush,COLOR_WINDOW
		ret
	.else
		mov eax,FALSE
		ret
	.endif
	mov eax,TRUE
	ret

DlgProc endp
